//+------------------------------------------------------------------+
//|                                                time_open_1_0.mq4 |
//|                                                    Andres  2010 |
//|                                                  http://mql5.su/ |
//+------------------------------------------------------------------+
#property copyright "Andres  2010"
#property link      "http://mql5.su/"

extern string vline_name="time";
extern double Lots=0.1; // 
extern int TP=10; // 
extern int SL=0; // 
extern datetime Open_Time=D'22.03.2010 13:00'; //  
extern int slippage=2;  //  
extern int MagicNumber=5345; //  
extern bool Open_Sell=false; ///   sell-
extern bool Open_Buy=false;  ///   buy-
extern bool Open_Sell_Stop=false; ///   sell stop-
extern bool Open_Buy_Stop=false;  ///   buy stop-
extern bool Open_Sell_Limit=false; ///   sell limit-
extern bool Open_Buy_Limit=false;  ///   buy limit-
extern int  Open_Level=30; //   ,     

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----


//+----------------------------------------------------------------------------------------------+
//|                                                                    |
    bool pos_sell=false;
  for (int i_op_sell=OrdersTotal()-1; i_op_sell>=0; i_op_sell--)
  {
   if (!OrderSelect(i_op_sell,SELECT_BY_POS,MODE_TRADES)) break;
   if (Symbol()==OrderSymbol()
   &&(OrderType()==OP_SELL||OrderType()==OP_SELLSTOP||OrderType()==OP_SELLLIMIT)
   &&(OrderMagicNumber()==MagicNumber)
   &&MathFloor(OrderOpenTime()/60)==TimeCurrent()/60)
   {
    pos_sell=true; break;  
   }
  }
    
    bool pos_buy=false;
  for (int i_op_buy=OrdersTotal()-1; i_op_buy>=0; i_op_buy--)
  {
   if (!OrderSelect(i_op_buy,SELECT_BY_POS,MODE_TRADES)) break;
   if (Symbol()==OrderSymbol()
   &&(OrderType()==OP_BUY||OrderType()==OP_BUYSTOP||OrderType()==OP_BUYLIMIT)
   &&(OrderMagicNumber()==MagicNumber)
    &&MathFloor(OrderOpenTime()/60)==TimeCurrent()/60)
   {
    pos_buy=true; break;  
   }
  }    
//|                                                                    |
//+----------------------------------------------------------------------------------------------+
//+--------------------------------------------+
//|                TP  SL               |    
  double sl_buy, sl_sell, tp_buy, tp_sell
  
         ,sl_buy_stop, sl_sell_stop,
         tp_buy_stop, tp_sell_stop
        
         ,sl_buy_limit, sl_sell_limit,
         tp_buy_limit, tp_sell_limit;
  if(!SL)
  {
   sl_buy=0;
   sl_sell=0;
  
   sl_buy_stop=0;
   sl_sell_stop=0;
  
   sl_buy_limit=0;
   sl_sell_limit=0;        
  }
  else
  {
   sl_buy=Bid-SL*Point;
   sl_sell=Ask+SL*Point;
  
   sl_buy_stop=Bid+Open_Level*Point-SL*Point;
   sl_sell_stop=Ask-Open_Level*Point+SL*Point;  
  
   sl_buy_limit=Bid-Open_Level*Point-SL*Point;
   sl_sell_limit=Ask+Open_Level*Point+SL*Point;    
  }

  if(!TP)
  {
   tp_buy=0;
   tp_sell=0;
  
   tp_buy_stop=0;
   tp_sell_stop=0;  
  
   tp_buy_limit=0;
   tp_sell_limit=0;    
  }
  else
  {
   tp_buy=Bid+TP*Point;
   tp_sell=Ask-TP*Point;
  
   tp_buy_stop=Bid+Open_Level*Point+TP*Point;
   tp_sell_stop=Ask-Open_Level*Point-TP*Point;    
  
   tp_buy_limit=Bid-Open_Level*Point+TP*Point;
   tp_sell_limit=Ask+Open_Level*Point-TP*Point;    
  }  
//|                TP  SL               |    
//+--------------------------------------------+


//+-----------------------------------------------------------------------------------------------------------+
//|                                                                                            |
 if(ObjectFind(vline_name)==-1)return(0);  
   datetime t=ObjectGet(vline_name,OBJPROP_TIME1);
if(t/60==TimeCurrent()/60)  
{
  if(!pos_buy)
  {
   if(Open_Buy)
   {
    OrderSend(Symbol(), OP_BUY, Lots, Ask, slippage, sl_buy,tp_buy, "time_open", MagicNumber, 0, NULL);  
   }
   if(Open_Buy_Stop)
   {
    OrderSend(Symbol(), OP_BUYSTOP, Lots, Ask+Open_Level*Point, slippage, sl_buy_stop,tp_buy_stop,
    "time_open", MagicNumber, 0, NULL);      
   }
  
   if(Open_Buy_Limit)
   {
    OrderSend(Symbol(), OP_BUYLIMIT, Lots, Ask-Open_Level*Point, slippage, sl_buy_limit,tp_buy_limit,
    "time_open", MagicNumber, 0, NULL);      
   }  
  }
  
  if(!pos_sell)
  {
   if(Open_Sell)
   {
    OrderSend(Symbol(), OP_SELL, Lots, Bid, slippage, sl_sell, tp_sell, "time_open", MagicNumber, 0, NULL);
   }
  
   if(Open_Sell_Stop)
   {
    OrderSend(Symbol(), OP_SELLSTOP, Lots, Bid-Open_Level*Point,slippage, sl_sell_stop, tp_sell_stop,
    "time_open", MagicNumber, 0, NULL);  
   }
  
   if(Open_Sell_Limit)
   {  
    OrderSend(Symbol(), OP_SELLLIMIT, Lots, Bid+Open_Level*Point,slippage, sl_sell_limit, tp_sell_limit,
    "time_open", MagicNumber, 0, NULL);    
   }    
  }  
}
int close_sellstop,close_buystop,cnt,total=OrdersTotal();
    for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         if(OrderType()==OP_BUY)
           {
            if(OrderOpenPrice()>0)
                {
                 Print("buy opened");
                 yDeleteOrder(5);
                 
                }
           }
         if(OrderType()==OP_SELL) 
           {
            if(OrderOpenPrice()>0)
                {
                 Print("Sell opened");
                 yDeleteOrder(4);
                }
           }
        }
     }

//|                                                                                            |
//+-----------------------------------------------------------------------------------------------------------+


//----
   return(0);
  }
//+------------------------------------------------------------------+
int yDeleteOrder(int type)
{
   for( int i=1; i<OrdersTotal(); i++)          
      {
         if(OrderSelect(i-1,SELECT_BY_POS)) 
            {                                       
               if(OrderType()==type && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
                  {
                     OrderDelete(OrderTicket()); 
                  }//if
  
           }//if
      }
   return(0);
}